<?php 

// +------------------------------------------------------------------+
// | Class Definition                                                 |
// +------------------------------------------------------------------+

class CORE_SkinFunc extends CORE_Display {

// +--
// | This file holds functions used by the main skin file.  It's 
// | purpose is to ensure the main skin file is as free of PHP
// | code as possible to make editing easier on end users.
// +--

// +------------------------------------------------------------------+
// | Class Variables                                                  |
// +------------------------------------------------------------------+

var $class   = 'CORE_SkinFunc';
var $version = '7.0.0';
var $cerror;

// +------------------------------------------------------------------+
// | Constructor Function                                             |
// +------------------------------------------------------------------+

function CORE_SkinFunc () {

// +--
// | This is the constructor function.  This function starts up the
// | class.  Any pre-load variable assignments go here.
// +--

// +--
// | Return $this.
// +--

return;

} // End of function.

// +------------------------------------------------------------------+
// | Function: startup                                                |
// +------------------------------------------------------------------+

function startup () {

// +--
// | This function loads variables for use within the skin.
// +--

// +--
// | Execute the Joomla! skin importer namespace to get the head
// | and body globalized.
// +--

$this->xnamespace('core','joomlaskinimporter');

// +--
// | Initialize the array.
// +--

$x = array();

// +--
// | General variables.
// +--

$x['disp_baseurl']   = $this->globals('core_display.base_url');

// +--
// | Meta tag and title variables.
// +--

$x['metatitle']    = $this->globals('core_display.metatitle');
$x['metakeywords'] = $this->globals('core_display.metakeywords');
$x['metadesc']     = $this->globals('core_display.metadesc');

// +--
// | Strip XHTML tags from the meta information.
// +--

$x['metatitle']    = $this->xhtml_encode(strip_tags($x['metatitle']));
$x['metakeywords'] = $this->xhtml_encode(strip_tags($x['metakeywords']));
$x['metadesc']     = $this->xhtml_encode(strip_tags($x['metadesc']));

// +--
// | Return our variable array.
// +--

return $x;

} // End of function.

// +------------------------------------------------------------------+
// | Function: xnamespace                                             |
// +------------------------------------------------------------------+

function xnamespace ($app = '', $namespace = '', $params = '') {

// +--
// | This function loads a requested namespace.
// +--

if ($app == 'core') {$app = $this->globals('core.app');}

if (empty($app)) {return false;}

$this->include_namespace($app,$namespace,$params,0);

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: link                                                   |
// +------------------------------------------------------------------+

function link ($app = '', $namespace = '', $params = '') {

// +--
// | This function returns a link to a namespace.
// +--

if ($app == 'core') {$app = $this->globals('core.app');}

if (empty($app)) {return false;}

// +--
// | Make sure the link is valid, otherwise, return false.
// +--

$valid = $this->link_isvalid($app,$namespace);

if (empty($valid)) {return false;}

// +--
// | Return the link if it's valid.
// +--

return $this->link_namespace($app,$namespace,$params);

} // End of function.

// +------------------------------------------------------------------+
// | Function: debug                                                  |
// +------------------------------------------------------------------+

function debug () {

// +--
// | This function prints closure and debug info.  It handle including 
// | the debug and closure divs.
// +--

if ($this->debug == 2) {$this->include_file('core','debug.php');}

$this->include_file('core','closure.php');

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: joomlahead                                             |
// +------------------------------------------------------------------+

function joomlahead () {

// +--
// | This function prints the Joomla! header contents.
// +--

$head = $this->globals('core.joomlaskinimporter_head');

if (empty($head)) {return 1;}

// +--
// | Parse and manipulate the head.
// +--

$begin_quoted = preg_quote('<head>','/');
$end_quoted   = preg_quote('</head>','/');
$head         = preg_replace('/^' . $begin_quoted . '(.*?)' . $end_quoted . '$/si','\\1',$head);

$head = $this->joomlafixurls($head);

// +--
// | Print the head.
// +--

print $head;

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: joomlabody                                             |
// +------------------------------------------------------------------+

function joomlabody () {

// +--
// | This function handles the inclusion of the Joomla! body contents.
// +--

$body = $this->globals('core.joomlaskinimporter_body');

if (empty($body)) {print '<core:content />'; return 1;}

// +--
// | Parse and manipulate the body.
// +--

$body = $this->joomlafixurls($body);

// +--
// | Print the body.
// +--

print $body;

$this->debug();

print '</body>';

// +--
// | Return true.
// +--

return 1;

} // End of function.


// +------------------------------------------------------------------+
// | Function: joomlafixurls                                          |
// +------------------------------------------------------------------+

function joomlafixurls ($content = '') {

// +--
// | This function fixes URLs in Joomla! output so as not to break
// | SSL or anything else.
// +--

if (empty($content)) {return $content;}

// +--
// | Figure out some preliminary stuff.
// +--

$replace      = array();

$current_port = $_SERVER['SERVER_PORT'];
$ssl_port     = $this->globals('core.port_ssl');

if ($current_port == $ssl_port) {

      $joomla_url  = $this->globals('core_settings.core.joomlaloc');
      $urlinfo     = parse_url($joomla_url);
      $pathinfo    = pathinfo($urlinfo['path']);
      $joomla_path = $pathinfo['dirname'];
      $joomla_url  = preg_replace('/' . preg_quote('/' . $pathinfo['basename'],'/') . '$/si','',$joomla_url);
      $system_url  = $this->globals('core.url_ssl') . '/' . $this->globals('core.script_frontend');
      $urlinfo     = parse_url($system_url);
      $pathinfo    = pathinfo($urlinfo['path']);
      $base_sslurl = preg_replace('/' . preg_quote($pathinfo['dirname'] . '/' . $pathinfo['basename'],'/') . '$/si','',$system_url);

      $joomla_url_ssl = $base_sslurl . $joomla_path;

      if (preg_match('/\/$/',$joomla_path)) {$joomla_url .= '/';}

      $replace[]   = array('find' => 'href="' . $joomla_path, 'replace' => 'href="' . $joomla_url);
      $replace[]   = array('find' => 'rel="stylesheet" href="' . $joomla_url, 'replace' => 'rel="stylesheet" href="' . $joomla_url_ssl);
      $replace[]   = array('find' => 'link href="' . $joomla_url, 'replace' => 'link href="' . $joomla_url_ssl);
      $replace[]   = array('find' => 'src="' . $joomla_path, 'replace' => 'src="' . $joomla_url_ssl);
      $replace[]   = array('find' => 'src="' . $joomla_url, 'replace' => 'src="' . $joomla_url_ssl);
      $replace[]   = array('find' => 'url(' . $joomla_url, 'replace' => 'url(' . $joomla_url_ssl);
      $replace[]   = array('find' => 'var siteurl = \'' . $joomla_url, 'replace' => 'var siteurl = \'' . $joomla_url_ssl);
      $replace[]   = array('find' => '@import "' . $joomla_url, 'replace' => '@import "' . $joomla_url_ssl);

} else {

      $joomla_url  = $this->globals('core_settings.core.joomlaloc');
      $urlinfo     = parse_url($joomla_url);
      $pathinfo    = pathinfo($urlinfo['path']);
      $joomla_path = $pathinfo['dirname'];

      $joomla_url  = preg_replace('/' . preg_quote('/' . $pathinfo['basename'],'/') . '$/si','',$joomla_url);

      if (preg_match('/\/$/',$joomla_path)) {$joomla_url .= '/';}

      $replace[]   = array('find' => 'href="' . $joomla_path, 'replace' => 'href="' . $joomla_url);
      $replace[]   = array('find' => 'src="' . $joomla_path, 'replace' => 'src="' . $joomla_url);

} // End of if statement.

// +--
// | Parse and manipulate the content.
// +--

if (!(empty($replace))) {

     foreach ($replace as $num => $action) {

          $find_quoted  = preg_quote($action['find'],'/');
          $content      = preg_replace('/' . $find_quoted . '/si',$action['replace'],$content);

     } // End of foreach statement.

} // End of if statement.

// +--
// | Remove Mootools if we've loaded it already.
// +--

if ($this->globals('core.load_mootools')) {

     $begin_quoted = preg_quote('<script type="text/javascript" src="','/');
     $end_quoted   = preg_quote('/mootools.js"></script>','/');
     $content      = preg_replace('/' . $begin_quoted . '.*?' . $end_quoted . '/si','',$content);

} // End of if statement.

// +--
// | Handle skin widget execution.
// +--

$content = preg_replace('/' . preg_quote('<skinwidget>','/') . '(.*?)' . preg_quote('</skinwidget>','/') . '/sie','$this->skinwidgetexec("\\1")',$content);

// +--
// | Insert the page title above the content.
// +--

$suppress_title = $this->globals('core_display.suppress_title');

$title = $this->xhtml_encode($this->globals('core.namespace.name'));
$title = preg_replace('/ \- Process$/','',$title);

if ($this->globals('core.ref_disp')) {$title = $this->xhtml_encode($this->globals('core.ref_disp'));}

if ((empty($suppress_title)) && (!(empty($title)))) {

     $content = preg_replace('/' . preg_quote('<core:content />','/') . '/si','<h1 class="componentheading">' . $title . '</h1><div id="skin_content"><core:content /></div>',$content);

} // End of if statement.

// +--
// | Remove the title tag and meta tags that we use.
// +--

$content = preg_replace('/' . preg_quote('<meta http-equiv="content-type"','/') . '.*?' . preg_quote(' />','/') . '/si','',$content);
$content = preg_replace('/' . preg_quote('<meta name="robots"','/') . '.*?' . preg_quote(' />','/') . '/si','',$content);
$content = preg_replace('/' . preg_quote('<meta name="keywords"','/') . '.*?' . preg_quote(' />','/') . '/si','',$content);
$content = preg_replace('/' . preg_quote('<meta name="description"','/') . '.*?' . preg_quote(' />','/') . '/si','',$content);
$content = preg_replace('/' . preg_quote('<meta name="generator"','/') . '.*?' . preg_quote(' />','/') . '/si','',$content);
$content = preg_replace('/' . preg_quote('<title>','/') . '.*?' . preg_quote('</title>','/') . '/si','',$content);

// +--
// | Handle a base href tag if there is one.
// +--

$content = preg_replace('/' . preg_quote('<base href="','/') . '.*?' . preg_quote(' />','/') . '/si','',$content);

// +--
// | Handle bad tags in forms.
// +--

$joomla_url = $this->globals('core_settings.core.joomlaloc');

$content = preg_replace('/' . preg_quote('<form action="index.php"','/') . '/si','<form action="' . $joomla_url . '"',$content);

// +--
// | Remove breadcrumbs.
// +--

$content = preg_replace('/' . preg_quote('<div id="ja-pathway">','/') . '.*?' . preg_quote('</div>','/') .  '/si','',$content);

// +--
// | Remove the ending body tag.
// +--

$content = preg_replace('/' . preg_quote('</body>','/') . '/si','',$content);

// +--
// | Remove 'option=com_{brand}'.
// +--

$brand    = $this->globals('core_settings.core.brand'); if (empty($brand)) {$brand = 'core';}

$com_name = 'com_' . strtolower($brand);

$content = preg_replace('/' . preg_quote('option=com_' . $com_name,'/') . '/si','option=',$content);
$content = preg_replace('/' . preg_quote('com_' . $com_name,'/') . '/si','',$content);
$content = preg_replace('/' . preg_quote('<input type="hidden" name="return" value="','/') . '.*?' . preg_quote('" />','/') . '/si','',$content);

$content = preg_replace('/' . preg_quote('action="','/') . '.*?' . preg_quote('/component/' . strtolower($brand),'/') . '.*?"/si','action="' . $joomla_url . '"',$content);

// +--
// | Return the fixed content.
// +--

return $content;

} // End of function.

// +------------------------------------------------------------------+
// | Function: robotstag                                              |
// +------------------------------------------------------------------+

function robotstag () {

// +--
// | This function prints the robots tag.  Follow/Index tags are
// | printed only when pages were not requested with SID in the URL.
// +--

$eol      = $this->globals('core.eol');
$cgi_sid  = $this->globals('core_cgi.sid');

if (!(empty($cgi_sid))) {

     print '<meta name="robots" content="noindex,follow" />' . $eol;

} else {

     print '<meta name="robots" content="index,follow" />' . $eol;

} // End of if statement.

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: content                                                |
// +------------------------------------------------------------------+

function content () {

// +--
// | This function prints the content placeholder.
// +--

print '<core:content />';

// +--
// | Return true.
// +--

return 1;

} // End of function.

// +------------------------------------------------------------------+
// | Function: skinwidgetexec                                         |
// +------------------------------------------------------------------+

function skinwidgetexec ($skinwidget = '') {

// +--
// | This function executes skin widgets based on a string passed to
// | it.
// +--

return $this->include_namespace('core','joomlaskinwidgetexec',$skinwidget,0);

} // End of function.

// +------------------------------------------------------------------+
// | End of Class                                                     |
// +------------------------------------------------------------------+

} // End of class.

// +------------------------------------------------------------------+
// | End Of File                                                      |
// +------------------------------------------------------------------+

?>